<template>
  <div>
    <!-- section header index -->
    <div class="header_style" v-if="data.section_home">
      <div v-if="data.section_home.header_banner">
        <img
          :src="data.section_home.header_banner.value"
          class="header_style img-fluid"
        />
      </div>
    </div>
    <!-- section New game & New Member -->
    <div class="bg_main mb-5" v-if="data.section_home">
      <div class="container">
        <div class="text-center mt-5">
          <h1 class="game_header" v-if="data.section_home.title_game">
            {{ data.section_home.title_game.value }}
          </h1>
          <h3
            class="game_description"
            v-if="data.section_home.description_game"
          >
            {{ data.section_home.description_game.value }}
          </h3>
          <div class="row p-0 my-5">
            <div v-if="data.section_home.banner_games">
              <VueSlickCarousel v-bind="settings_games">
                <img
                  v-for="(item, index) in data.section_home.banner_games.values"
                  :key="index"
                  :src="item.image"
                  :alt="item.alt"
                />
              </VueSlickCarousel>
            </div>
          </div>
          <div class="row p-0">
            <div
              class="col-md-4"
              v-if="data.section_home.banner_games_of_the_month"
            >
              <img
                class="img-fluid"
                :src="data.section_home.banner_games_of_the_month.value"
              />
            </div>
            <div
              class="col-md-4"
              v-if="data.section_home.banner_games_of_the_month_2"
            >
              <img
                class="img-fluid"
                :src="data.section_home.banner_games_of_the_month_2.value"
              />
            </div>
            <div
              class="col-md-4"
              v-if="data.section_home.banner_games_of_the_month_3"
            >
              <img
                class="img-fluid"
                :src="data.section_home.banner_games_of_the_month_3.value"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- section welcome Demo Desktop-->
    <div class="bg_welcome d-none d-md-block" v-if="data.section_home">
      <div class="container">
        <div class="row p-0">
          <div class="col-md-12 mt-5 p-0">
            <div class="mt-5 py-5">
              <h1
                class="header_welcome"
                v-if="data.section_home.header_welcome"
              >
                &nbsp;&nbsp; {{ data.section_home.header_welcome.value }}
              </h1>
              <h2
                class="header_welcome2"
                v-if="data.section_home.header_welcome_2"
              >
                {{ data.section_home.header_welcome_2.value }}
              </h2>
              <p
                class="content_welcome mt-5 mb-5"
                v-if="data.section_home.content_welcome"
              >
                {{ data.section_home.content_welcome.value }}
              </p>
              <button
                class="btn_register"
                v-if="data.section_home.btn_register_welcome"
              >
                <img
                  :src="data.section_home.btn_register_welcome.value"
                  class="img-fluid"
                />
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- section welcome mobile -->
    <div class="bg_welcome_mobile d-block d-md-none" >
      <div class="container" v-if="data.section_home">
        <div class="row p-0">
          <!-- <div  v-if="data.section_home.btn_register_mobile">
            <img class="img-fluid" :src="data.section_home.btn_register_mobile.value" />
          </div> -->
        </div>
      </div>
    </div>

    <!-- section promotion -->
    <div class="bg_promotion" v-if="data.section_home">
      <div class="container">
        <div style="text-align: center">
          <div class="row p-0">
            <div class="col mt-5" v-if="data.section_home.header_promotion">
              <h1 class="promotion_header mb-5">
                {{ data.section_home.header_promotion.value }}
              </h1>
              <div>
                <VueSlickCarousel v-bind="settings_promotions">
                  <img
                    class="img-fluid"
                    v-for="(item, index) in data.section_home.banners_promotion
                      .values"
                    :key="index"
                    :src="item.image"
                    :alt="item.alt"
                  />
                </VueSlickCarousel>
              </div>
              <div class="mt-5">
                <h1
                  class="promotion_header"
                  v-if="data.section_home.header_promotion_2"
                >
                  {{ data.section_home.header_promotion_2.value }}
                </h1>
                <h4
                  class="promotion_content mt-5 mb-5"
                  v-if="data.section_home.content_promotion"
                >
                  {{ data.section_home.content_promotion.value }}
                </h4>
                <button
                  class="btn_demo"
                  v-if="data.section_home.btn_line_promotion"
                >
                  <img
                    class="img-fluid"
                    :src="data.section_home.btn_line_promotion.value"
                  />
                </button>
              </div>
              <img class="img-fluid" :src="data.section_home.coin_bg.value" />
            </div>
          </div>
        </div>
      </div>
      <div v-if="data.section_home.banner_step">
        <img
          :src="data.section_home.banner_step.value"
          class="img-fluid d-none d-md-block"
        />
        <img
          :src="data.section_home.banner_step_mobile.value"
          class="img-fluid d-block d-md-none"
        />
      </div>
    </div>
  </div>
</template>

<script>
import VueSlickCarousel from "vue-slick-carousel";
import "vue-slick-carousel/dist/vue-slick-carousel.css";
// optional style for arrows & dots
import "vue-slick-carousel/dist/vue-slick-carousel-theme.css";

export default {
  components: { VueSlickCarousel },
  data() {
    return {
      data: {
        section_home: [],
      },
      isloadding: false,
      settings_promotions: {
        arrows: false,
        dots: true,
        infinite: true,
        // slidesToShow: 3,
        slidesToScroll: 1,
        autoplay: true,
        speed: 1000,
        autoplaySpeed: 5000,
      },
      settings_games: {
        arrows: false,
        dots: true,
        infinite: true,
        slidesToShow: 4,
        slidesToScroll: 1,
        autoplay: true,
        speed: 1000,
        autoplaySpeed: 5000,
        responsive: [
          {
            breakpoint: 1024,
            settings: {
              slidesToShow: 4,
              slidesToScroll: 1,
              infinite: true,
              dots: false,
            },
          },
          {
            breakpoint: 600,
            settings: {
              slidesToShow: 2,
              slidesToScroll: 1,
              initialSlide: 1,
              infinite: true,
              dots: false,
            },
          },
          {
            breakpoint: 480,
            settings: {
              slidesToShow: 2,
              slidesToScroll: 1,
              infinite: true,
              dots: false,
            },
          },
        ],
      },
    };
  },

  async beforeMount() {
    this.GetData();
  },
  methods: {
    isFormat(temp, current) {
      for (let key in temp) {
        if (!Object.keys(current).includes(key)) {
          return false;
        }
      }
      return true;
    },
    async addStyle() {
      for (const [key, v] of Object.entries(this.data)) {
        if (typeof v === "object") {
          for (const [k, val] of Object.entries(v)) {
            if (val.type == "color") {
              document.documentElement.style.setProperty(
                `--${key}_${val.name}`,
                val.value
              );
            } else if (val.type == "image") {
              document.documentElement.style.setProperty(
                `--${key}_${val.name}`,
                `url(${val.value})`
              );
            }
          }
        }
      }
    },
    async GetData() {
      try {
        // const url = "http://" + window.location.host + "/get.php";
        // let {data} = await this.$axios.get('/get.php?code_name='+md5);
        this.isloadding = true;
        let { data } = await this.$axios.get("/get_winbet97.json");

        // let { data } = await this.$axios.get(
        //   "https://admin-static-api-ehhif4jpyq-as.a.run.app/api/Static/ab1e389ef2852fb41d6d3c68fb252370"
        // );

        this.data = await this.mapSectionData(data);
        if (this.data) {
          this.addStyle();
        }
        this.componentKey += 1;
        this.isloadding = false;

        // console.log("this.isloadding ", this.isloadding);
        return true;
      } catch (error) {
        console.log(error);
        const { response } = error;
        if (response) {
          const { status } = response;
          if (!status) {
            this.$router.push({
              path: "/400",
              query: { message: error.response.data.message },
            });
            return false;
          } else if (status === 200) {
            console.log("Error is ok");
          } else if (status === 404) {
            this.$router.push({
              path: "/404",
              query: { message: response.data.message },
            });
            console.log("is invalid or not found");
            // this.$swal("is invalid or not found");
            return false;
          } else {
            this.$router.push({
              path: "/400",
              query: { message: error.response.data.message },
            });
            // console.log(" is under maintainance with custom message");
            // this.$swal("is under maintainance with custom message");
            return false;
          }
        } else {
          console.log(error);
          this.$router.push({
            path: "/400",
            query: { message: "server is not responding" },
          });
          // this.$swal("is invalid or not found 3");
          return false;
        }

        // console.log("500");
      }
    },

    mapSectionData(data) {
      for (let key in data) {
        if (typeof data[key] === "object") {
          data[key] = data[key].reduce(function (map, value) {
            map[value.name] = value;
            return map;
          }, {});
        }
      }
      return data;
    },
  },
};
</script>

